#include "Rational.h"
#include <iostream.h>
#include <math.h>
#include "DivideByZeroException.h"

int main() {

	Rational r1;
	Rational r2(2);
	Rational r3(3,4);
	Rational r4(4,3);
	
	Rational r10 = r4;
	
	Rational r5 = r1 + r2;
	
	// should be (3/1) and (11/4) 
	cout << "Hypothesis: (3/1) (11/4)   Actual: ";
	cout << r5 << " "<< (r2 + r3) << endl;
	
	// should be (1/1)
	cout << "Hypothesis: (1/1)    Actual: "; 
	cout << r3 * r4 << endl;
	
	// should be (1/1)
	cout << "Hypothesis: (1/1)    Actual: "; 
	cout << r3 / r3 << endl;
	
	// should (-1/4) 
	cout << "Hypothesis: (-1,4)    Actual: "; 
	cout << r3 - r1 << endl;
	
	// should be (2/1) (4/1) (1/2)	
	cout << "Hypothesis: (2/1) (4/1) (1/2)   Actual: "; 
	cout << r2 << " " << r2.power(2) << " " << r2.power(-1) << endl;
	
	
	// should be true (or 1)
	cout << "Hypothesis: 1   Actual: ";
	cout << ((r3 / r3) == r1) << endl;
	
	// should output (2/1) but r2 is now (3/1)
	cout << "Hypothesis: (2/1)   Actual: ";
	cout << r2++ << endl;
	
	// should update the value to (4/1) and then output (4/1)
	cout << "Hypothesis: (4/1)   Actual: ";
	cout << ++r2 << endl;

	// exception should be thrown and caught
	try {
		Rational r1(3,0);
	} catch (DivideByZeroException& dbze) {
		cout << "Hypothesis: Divide By Zero Exception   Actual: ";
		cout << dbze << endl;
	}
}